;     .  1.0
;                                                  . . 9/02/2002

LIST p=16F84a

; 
; CONSTANT	U165=.111		;     
; CONSTANT	U195=.148		;  .
; CONSTANT	U210=.162
; CONSTANT	U230=.179
; CONSTANT	U245=.190
; CONSTANT	U260=.198
; CONSTANT	U260=.198
; CONSTANT	POWER_ON=.128		;      (5 .)
; CONSTANT	PWON_ERL=.250		;     , 
; CONSTANT	PWON_ERH=.1		;   (10)
; CONSTANT	CONFIG=.0		;  0- UPS, 1-  UPS
;*********     *****************************************
U165         EQU   .111
U195         EQU   .148
U210         EQU   .162
U230         EQU   .187
U245         EQU   .193
U260         EQU   .203
U275         EQU   .208
POWER_ON     EQU   .128
PWON_ERL     EQU   .250
PWON_ERH     EQU   .1   ;   (10)
CONFUPS      EQU   .0  ;  0- UPS, 1-  UPS  !!! !!!
;   
RTCC	     EQU   0x01
TRISA	     EQU   0x85
TRISB        EQU   0x86
STATUS       EQU   3
RP0          EQU   5
PORTA	     EQU   0x05
PORTB	     EQU   0x06
OPTIONS	     EQU   0x81
INTCON	     EQU   0x0B
C	     EQU   0
Z	     EQU   2
TEMP	     EQU   0x0C
T_OFF        EQU   0x0D
T_ONL	     EQU   0x0E
T_ONH        EQU   0x0F
TS1          EQU   0x10
TS2	     EQU   0x11
TS3	     EQU   0x12
FLAGS	     EQU   0x13
REZ_U	     EQU   0x14
REZ_U2	     EQU   0x15
OLD_U	     EQU   0x16

	;    
	BSF     STATUS, RP0	;   1 
        MOVLW 	B'00000001'	;  0  A  ,   U.
	MOVWF	TRISA
        MOVLW 	B'10000000'	
	MOVWF	TRISB		;  7    ,   .
        MOVLW	B'11000100'	;      
	MOVWF	OPTIONS		; 1:32,      
	BCF     STATUS, RP0     ;   0 
	CLRF	PORTA
	CLRF	PORTB
	BTFSC	STATUS, 4
	GOTO	L50
L51	BSF	PORTB, 6	;   WDT    
	BCF	PORTB, 5	;,       
	BSF	PORTB, 4
	BCF	PORTA, 2	;   
	BCF	PORTA, 3	
	BCF	PORTB, 0
	BCF	PORTB, 1
	BCF	PORTB, 2
	BCF	PORTB, 3
	BTFSS	PORTB, 7
	GOTO	L51				
L50	CLRF	INTCON
	BCF	PORTB, 5
	BSF	PORTB, 6
	BSF	PORTB, 4
	MOVLW	.250		; 0.5        
	MOVWF	T_OFF
L29	CLRF	RTCC		
	BCF	PORTA, 2	;   
	BCF	PORTA, 3	
	BCF	PORTB, 0
	BCF	PORTB, 1
	BCF	PORTB, 2
	BCF	PORTB, 3
L28	CLRWDT
	MOVF	RTCC, 0
	SUBLW	.250
	BTFSC	STATUS, C	
	GOTO	L28	
	DECFSZ	T_OFF
	GOTO	L29	
	CALL	LEVEL_U
	CALL	LEVEL_U
	CALL	LEVEL_U
	BCF	FLAGS, 1
	MOVLW	.1
	SUBLW	CONFUPS
	BTFSC	STATUS, Z
	BSF	FLAGS, 1	;    UPS
	MOVLW	.1		;     10  
	MOVWF	T_ONH		; .
	MOVLW	POWER_ON
	MOVWF	T_ONL
	BSF	FLAGS, 0
	BCF	PORTB, 6
	BCF	PORTB, 4
	BSF	PORTB, 5
	GOTO	L22
	
	;       
L5	BSF     STATUS, RP0	;   1   	( )
	MOVLW	B'11000100'	;      
	MOVWF	OPTIONS		; 1:32,      
	BCF     STATUS, RP0	;   1 
	BCF	FLAGS, 0
	BSF	PORTB, 5
	MOVF	REZ_U, 0	;   
	MOVWF	OLD_U
L19	CALL	LEVEL_U		;   	
	MOVWF	REZ_U
	CALL	LEVEL_U		;    	
	SUBWF	REZ_U, 0	;    
	BTFSS	STATUS, Z
	GOTO	L19		;     
	BTFSS	PORTB, 7	;      
	GOTO	L40		
	BCF	PORTB, 5
L47	MOVLW	.200		;       2 .
	MOVWF	TEMP
L46	CLRF	RTCC	
L45	CLRWDT
	BTFSS	PORTB, 7	
	GOTO	L40		
	MOVF	RTCC, 0
	SUBLW	.250
	BTFSC	STATUS, C	
	GOTO	L45
	DECFSZ	TEMP, 1
	GOTO	L46
	BCF	FLAGS, 0
	GOTO	L20		;  ,     
L40	BCF	PORTA, 2	;   
	BCF	PORTA, 3	
	BCF	PORTB, 0
	BCF	PORTB, 1
	BCF	PORTB, 2
	BCF	PORTB, 3
	BSF	PORTB, 5
	MOVF	REZ_U, 0	;        
	SUBWF	OLD_U, 0	; 
	BTFSC	STATUS, Z
	GOTO	U0		;   
	CLRF	RTCC		; 1,    
L17	CLRWDT
	MOVF	RTCC, 0
	SUBLW	.20
	BTFSC	STATUS, C	
	GOTO	L17	
	;  
U0	MOVF	REZ_U, 1	;U < 145	
	BTFSS	STATUS, Z
	GOTO	U1
	DECFSZ	T_OFF, 1	;  
	GOTO	L30
	MOVLW	.10
	MOVWF	T_OFF
	BCF	FLAGS, 0
	GOTO	L20		;  ,     
L30	BSF	PORTA, 2
	BSF	PORTB, 3
	GOTO	L5

U1 	MOVLW	.1		;145 < U < 165
	SUBWF	REZ_U, 0
	BTFSS	STATUS, Z
	GOTO	U2
	MOVLW	.7
	MOVWF	T_OFF
	CALL	SIGNAL1
	BSF	PORTA, 2
	BSF	PORTB, 3
	GOTO	L5
U2	MOVLW	.2		;165 < U < 195
	SUBWF	REZ_U, 0
	BTFSS	STATUS, Z
	GOTO	U3
	MOVLW	.7
	MOVWF	T_OFF
	BCF	PORTB, 4
	BCF	PORTB, 6
	BSF	PORTA, 2
	BSF	PORTB, 3
	GOTO	L5
U3	MOVLW	.3		;195 < U < 210
	SUBWF	REZ_U, 0
	BTFSS	STATUS, Z
	GOTO	U4
	MOVLW	.7
	MOVWF	T_OFF
	BCF	PORTB, 4
	BCF	PORTB, 6
	BSF	PORTA, 2
	BSF	PORTB, 2
	GOTO	L5
U4	MOVLW	.4		;210 < U < 230
	SUBWF	REZ_U, 0
	BTFSS	STATUS, Z
	GOTO	U5
	MOVLW	.7
	MOVWF	T_OFF
	BCF	PORTB, 4
	BCF	PORTB, 6
	BSF	PORTA, 2
	BSF	PORTB, 1
	GOTO	L5
U5	MOVLW	.5		;230 < U < 245
	SUBWF	REZ_U, 0
	BTFSS	STATUS, Z
	GOTO	U6		
	MOVLW	.7
	MOVWF	T_OFF
	BCF	PORTB, 4
	BCF	PORTB, 6
	BSF	PORTA, 2
	BSF	PORTB, 0
	GOTO	L5
U6	MOVLW	.6		;245 < U < 260
	SUBWF	REZ_U, 0
	BTFSS	STATUS, Z
	GOTO	U7		
	MOVLW	.7
	MOVWF	T_OFF
	BCF	PORTB, 4
	BCF	PORTB, 6
	BSF	PORTA, 2
	BSF	PORTA, 3
	GOTO	L5
U7	MOVLW	.7		;260 < U < 275
	SUBWF	REZ_U, 0
	BTFSS	STATUS, Z
	GOTO	U8		
	MOVLW	.7
	MOVWF	T_OFF
	CALL	SIGNAL2
	BSF	PORTA, 2
	BSF	PORTA, 3
	GOTO	L5
U8	MOVLW	.7
	MOVWF	T_OFF
	BCF	FLAGS, 0
	GOTO	L20		;U > 275,   
	
	;     
L20	BCF	PORTA, 2	;     (  )
	BCF	PORTA, 3	
	BCF	PORTB, 0
	BCF	PORTB, 1
	BCF	PORTB, 2
	BCF	PORTB, 3
L21	MOVLW	PWON_ERH	;       
	MOVWF	T_ONH
	MOVLW	PWON_ERL
	MOVWF	T_ONL
L22	CLRWDT
	BSF     STATUS, RP0	;   1   	( )
	MOVLW	B'11000100'	;      
	MOVWF	OPTIONS		; 1:32,      
	BCF     STATUS, RP0	;   1 
	DECFSZ	T_ONL, 1
	GOTO	L23
	DECFSZ	T_ONH, 1
	GOTO	L23
	GOTO	L25
L23	CALL	LEVEL_U		;   	
	MOVWF	REZ_U
	CALL	LEVEL_U		;    	
	SUBWF	REZ_U, 0	;    
	BTFSS	STATUS, Z
	GOTO	L23		;     
	CALL	SIGNAL3
	;  
U2_0	MOVF	REZ_U, 1	;U < 145	
	BTFSS	STATUS, Z
	GOTO	U2_1
	BCF	PORTB, 4
	BCF	PORTB, 5
	BSF	PORTB, 6
	GOTO	L21		;   
U2_1	MOVLW	.1		;145 < U < 165
	SUBWF	REZ_U, 0
	BTFSS	STATUS, Z
	GOTO	U2_2
	BCF	PORTB, 4
	BCF	PORTB, 5
	BSF	PORTB, 6
	GOTO	L21		;   
	CALL	SIGNAL1
	CALL	SIGNAL3
	BCF	PORTB, 4
	GOTO	L22
U2_2	MOVLW	.2		;165 < U < 195
	SUBWF	REZ_U, 0
	BTFSS	STATUS, Z
	GOTO	U2_3
	BCF	PORTB, 4
	BCF	PORTB, 6
	CALL	SIGNAL3
	GOTO	L22
U2_3	MOVLW	.3		;195 < U < 210
	SUBWF	REZ_U, 0
	BTFSS	STATUS, Z
	GOTO	U2_4
	BCF	PORTB, 4
	BCF	PORTB, 6
	CALL	SIGNAL3
	GOTO	L22
U2_4	MOVLW	.4		;210 < U < 230
	SUBWF	REZ_U, 0
	BTFSS	STATUS, Z
	GOTO	U2_5
	BCF	PORTB, 4
	BCF	PORTB, 6
	CALL	SIGNAL3
	GOTO	L22
U2_5	MOVLW	.5		;230 < U < 245
	SUBWF	REZ_U, 0
	BTFSS	STATUS, Z
	GOTO	U2_6		
	BCF	PORTB, 4
	BCF	PORTB, 6
	CALL	SIGNAL3
	GOTO	L22
U2_6	MOVLW	.6		;245 < U < 260
	SUBWF	REZ_U, 0
	BTFSS	STATUS, Z
	GOTO	U2_7		
	BCF	PORTB, 4
	BCF	PORTB, 6
	CALL	SIGNAL3
	GOTO	L22
U2_7	MOVLW	.7		;260 < U < 275
	SUBWF	REZ_U, 0
	BTFSS	STATUS, Z
	GOTO	U2_8		
	CALL	SIGNAL3
	CALL	SIGNAL2
	BCF	PORTB, 6
	GOTO	L22
U2_8	BSF	PORTB, 4
	BCF	PORTB, 5
	BCF	PORTB, 6
	GOTO	L21		;U > 275,    
	
	;  ,      
L25	CLRWDT
	MOVLW	.1		;   
	MOVWF	T_ONH
	MOVLW	.2
	MOVWF	T_ONL
	BSF	PORTB, 5
	BTFSC	FLAGS, 0
	GOTO	L41		;   ,      
	BTFSC	FLAGS, 1
	GOTO	L41		;   ,      
	BTFSS	PORTB, 7
	GOTO	L22		;   ,   
L41	BSF	PORTA, 2
	BCF	PORTB, 5
	MOVLW	.4
	MOVWF	REZ_U
	MOVLW	.100
	MOVWF	TEMP
L42	CLRF	RTCC		
L43	CLRWDT
	BTFSC	PORTB, 7
	GOTO	L41
	MOVF	RTCC, 0
	SUBLW	.250
	BTFSC	STATUS, C	
	GOTO	L43
	DECFSZ	TEMP, 1
	GOTO	L42	
	BSF	PORTB, 5
	GOTO	L5		;   

;   "" 
SIGNAL1	INCF	TS1, 1
	MOVF	TS1, 0
	SUBLW	.30
	BTFSS	STATUS, C
	CLRF	TS1			;IF TS>128 THEN TS:=0
	MOVF	TS1, 0
	SUBLW	.10
	BTFSC	STATUS, C
	GOTO	L6
	BSF	PORTB, 6		;TS > .64
	RETURN		
L6	BCF	PORTB, 6		;TS < .64
	RETURN

;   "" 
SIGNAL2	INCF	TS2, 1
	MOVF	TS2, 0
	SUBLW	.30
	BTFSS	STATUS, C
	CLRF	TS2			;IF TS>128 THEN TS:=0
	MOVF	TS2, 0
	SUBLW	.10
	BTFSC	STATUS, C
	GOTO	L7
	BSF	PORTB, 4		;TS > .64
	RETURN		
L7	BCF	PORTB, 4		;TS < .64
	RETURN

;   "" 
SIGNAL3	INCF	TS3, 1
	MOVF	TS3, 0
	SUBLW	.30
	BTFSS	STATUS, C
	CLRF	TS3			;IF TS>128 THEN TS:=0
	MOVF	TS3, 0
	SUBLW	.10
	BTFSC	STATUS, C
	GOTO	L15
	BCF	PORTB, 5		;TS > .64
	RETURN		
L15	BSF	PORTB, 5		;TS < .64
	RETURN

;        (10ms),  
;  WREG   :
;0 - U < 145			:  
;1 - 145 < U < 165 		;  ,    ""
;2 - 165 < U < 195		;
;3 - 195 < U < 210		
;4 - 210 < U < 230		
;5 - 230 < U < 245
;6 - 245 < U < 260
;7 - 260 < U < 275		;  ,    ""
;8 - U > 275			:  
LEVEL_U	CLRF	RTCC		;  .
L13	CLRWDT
	BTFSC	PORTA, 0	;      
	GOTO	L14		;    
	MOVF	RTCC, 0		;   6    
	SUBLW	U275		;     U > 275 
	BTFSS	STATUS, C	
	RETLW	.8	
	GOTO	L13	
L14	CLRF	RTCC
	MOVLW	.5
	MOVWF	TEMP
L1	CLRWDT
	BTFSS	PORTA, 0	;      
	GOTO	L2
	MOVF	RTCC, 0		;   40    
	SUBLW	.250		;     U < 145
	BTFSC	STATUS, C	
	GOTO	L1
	CLRF	RTCC
	DECFSZ	TEMP, 1
	GOTO	L1
	RETLW	0
L2	CLRF	RTCC		;  .
L3	CLRWDT
	BTFSC	PORTA, 0	;     
	GOTO	L4
	MOVF	RTCC, 0		;   6    
	SUBLW	U275		;     U > 275 
	BTFSS	STATUS, C	
	RETLW	.8
	GOTO	L3	
L4	MOVF	RTCC, 0		;   
	MOVWF	TEMP
	MOVF	TEMP, 1		;  
	BTFSC	STATUS, Z
	GOTO	LEVEL_U
	;       
	MOVLW	U165		;< 165V
	SUBWF	TEMP, 0
	BTFSS	STATUS, C
	RETLW	.1
	MOVLW	U165+3		
	SUBWF	TEMP, 0
	BTFSS	STATUS, C
	GOTO	L16		
	MOVLW	U195		;165 < U < 195
	SUBWF	TEMP, 0			
	BTFSS	STATUS, C
	RETLW	.2
	MOVLW	U195+3		
	SUBWF	TEMP, 0
	BTFSS	STATUS, C
	GOTO	L16		
	MOVLW	U210		;195 < U < 210
	SUBWF	TEMP, 0
	BTFSS	STATUS, C
	RETLW	.3
	MOVLW	U210+3		
	SUBWF	TEMP, 0
	BTFSS	STATUS, C
	GOTO	L16		
	MOVLW	U230		;210 < U < 230
	SUBWF	TEMP, 0
	BTFSS	STATUS, C
	RETLW	.4		
	MOVLW	U230+2		
	SUBWF	TEMP, 0
	BTFSS	STATUS, C
	GOTO	L16		
	MOVLW	U245		;230 < U < 245
	SUBWF	TEMP, 0
	BTFSS	STATUS, C
	RETLW	.5		
	MOVLW	U245+1		
	SUBWF	TEMP, 0
	BTFSS	STATUS, C
	GOTO	L16		
	MOVLW	U260		;245 < U < 260
	SUBWF	TEMP, 0
	BTFSS	STATUS, C
	RETLW	.6
	MOVLW	U260+1		
	SUBWF	TEMP, 0
	BTFSS	STATUS, C
	GOTO	L16		
	MOVLW	U275		;260 < U < 275
	SUBWF	TEMP, 0
	BTFSS	STATUS, C
	RETLW	.7		
	RETLW	.8		;U > 275
L16	MOVF	REZ_U, 0
	RETURN

	END


